program rnr;  {russell's news reader/poster}  {formerly `rusnews'}

{

Russell Schulz - russell@alpha3.ersys.edmonton.ab.ca (950327)

}

{

KNOWN SHORTCOMINGS (but don't let them scare you away - they're pessimistic)

(see also rnr.fut for future considerations)

no 'f'ollowups for non-trusted users
does not use the b-tree index for Waffle 1.65's password file for higher speed
will use the first rnews.exe found in the current directory+path - be careful
  with the directory you run this from - for sure not the user's home dir!
cannot 'G'oto a group not already in your join file
at most 400 articles/group selectable (but you can usually go back for more)
  smaller-memory version: 60 articles/group
crossposts detected/filtered using at most 200 groups in join file
  smaller-memory version: 120 groups used in detection
very limited kill/antikill files
  no regular expression searches
  restricted to Subject: and From: only (substring or not,
    case sensitive or not - selectable)
  at most 150 killed/antikilled items/group
    smaller-memory version: 50 killed/antikilled items/group
threading doesn't use References: data as much as it could - but
  it hashes them for much smaller space requirements now, so it should
  be fine except in the case of hash collisions - perfect detection of
  references sacrificed for space savings
doesn't log outgoing mail in ~waffle/admin/mail
doesn't guess when daylight savings hits
  (you have to change the clock on your pc anyway, and the policy about
  when to switch is different around the world)
has no simple built-in editor
does not use waffle's editor information from STATUS command or _editors file
has no good way to send time limit information to editor program
only understands %A, %W, %n, %u, %F, %i waffle parameters (and fake %f)
  (for static netmail:/netnews:/replyto: entries)
to get around waffle's rnews.exe continuation line noncompliance it doesn't
  keep lines to 80 columns (in the References: line)
any outgoing line more than 255 chars will be truncated somewhere still

KNOWN WEIRDNESS

'r'eply and 'f'ollow make you be careful with sig
  (but it works)
    (except with very long posts if you have a lousy editor)
  (this helps prevent double sig enclosure, for sure!)
'P'revious group needs work (in case where all articles are read)
leaves files laying around in temporary directory - could be handy, since
  sometimes rnews fails without an errorlevel, but could also get in your
  way - you may want to delete them periodically

ENVIRONMENT VARIABLES

WAFFLE - same as waffle requires it - full pathname of static file
  if not there, uses `static' in current directory
NET_NAME or USER  - user's waffle user id
  also -u/--user
EDITOR - full path+extension of editor (default: c:\usr\bin\vi.exe)
  also -e/--editor - see also -o/--editor-options
  as of v0.96 full path should no longer be required - extension still is
TZ - time zone; default: `MDT' (if not found in static file)
FULLNAME - full real-world name of user
  also -f/--fullname (underscores changed to spaces)
  should not be necessary for Waffle 1.64 and 1.65
WAFFLEVERSION - version of waffle; default: `1.64'
  also static entry: version; also -v/--waffle-version

CREDITS

Kim Storm, for the `nn' newsreader (a much more powerful newsreader
  for Unix, some of whose keystrokes were used here (not Unix, nn))

Bill Fenner, author of PWPL165.ZIP from simtel20, who allowed me
  to know what was where in the 1.65 password file with no guessing

Rhys Weatherley, who suggested hashing the Message-ID: and References:
  lines for better threading accuracy without taking much space

Henrik Storner, who did all of the UUPC work and found various errors

}

{create a .TPM file for tp4}

{$ifdef VER40}
{$T+} 
{$endif}

{$I rnr-def.pas}

{$ifdef tiny}
{$M 24576,0,27000}
{$else}
{$ifdef manyarts}
{$M 45056,190000,210000}
{$else}
{$M 45056,140000,160000}
{$endif}
{$endif}

uses rnrglob,rnrio,rnrfunc,rnrproc,rnrinit,rnrmain,rnrselb

{$ifdef timeout}

,rnrtime

{$endif}

;



begin

  initialize;

{$ifdef debug}
  execp('c:\usr\bin\freem.exe','');
  xwrites(newsreadername);
  xwrites(': freem: doserror=');
  xwritei(doserror);
  xwriteln;
{$endif}

  repeat

    if alreadyingroup then
      alreadyingroup := false
    else
      currgroup := getnextgroup;
    if currgroup<>'' then
      begin

        if clearscreenbetweengroups then
          xclrscr;

        xwritelnss('group found=',currgroup);

        groupinit;
        if groupdir<>'' then
          begin
            findhighest;

{make life easier for mouse users}
            xwritelns('Reading...  (or use ! Q N O)');

            readinarts;
            if not nextwhilereading then
              begin

{all these routines handle numarts=0 just fine - but it cuts down on output}
                if numarts>0 then
                  begin
                    xwrites('Sorting ');
                    if numarts>1 then
                      begin
                        xwritei(numarts);
                        xwrites(' articles...');
                      end
                    else
                      xwrites('1 article...');
                    sortitall;

                    if unscannedarts then
                      warn('not all articles read in!');

{$ifdef testsort}
                    xwrites('pausing...');
                    xwritelns(xreadkey);
{$endif}

              {
                    for i := 1 to numarts do
                      writeln(filenamesp^[i]:14,' ',
                       datesp^[i] div 16384:4,' ',
                       (datesp^[i] mod 16384) div 1024:2,' ',
                       (datesp^[i] mod 1024) div 32:2,' ',
                       datesp^[i] mod 32:2,' ',
                       indents[i]:3,' ',
                       copy(basesubjs[i],1,50));
              }

                    selectandbrowse;
                    updatejoin(highestread);
                  end;
              end;
          end;
      end;
  until currgroup='';
  shutdown(0);
end.